function varargout = OsSim(varargin)

% Funcin inicial de la interfaz grfica

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @OsSim_OpeningFcn, ...
                   'gui_OutputFcn',  @OsSim_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

end


function OsSim_OpeningFcn(hObject, eventdata, handles, varargin)

% Configuracin inicial de la interfaz

scrsz = get(0,'ScreenSize');
pos_act=get(gcf,'Position');
xr=scrsz(3) - pos_act(3);
xp=round(xr/2);
yr=scrsz(4) - pos_act(4);
yp=round(yr/2);
set(gcf,'Position',[xp yp pos_act(3) pos_act(4)])

handles.output = hObject;

% Valores iniciales para las funciones lnea y contorno

b='-';
handles.b = b;
a=1;
handles.a = a;
val='r';
handles.val = val;
val2='r';
handles.val2 = val2;
guidata(hObject, handles);
msg=0;
K4=0;
K5=0;
f=0;
dx='0';
dx=char(dx);
dy='0';
dy=char(dy);

handles.f =f;
guidata(hObject, handles);
handles.K5 =K5;
guidata(hObject, handles);
handles.msg = msg;
guidata(hObject, handles);
handles.K4 = K4;
guidata(hObject, handles);
handles.dx = dx;
guidata(hObject, handles);
handles.dy = dy;
guidata(hObject, handles);
% Muestra un recuadro negro inicial donde va a estar colocada la imagen

axes(handles.axes2)
A=zeros(500,500);
imshow(A)
axis off
 
axes(handles.axes3)
A=zeros(500,500);
imshow(A)
axis off
 
% Zoom y span
th = uitoolbar;
A=uitoolfactory(th, 'Exploration.ZoomIn');
B=uitoolfactory(th, 'Exploration.ZoomOut') ;
uitoolfactory(th, 'Exploration.Pan');
% uitoolfactory(th, 'Exploration.DataCursor'); 

end


function varargout = OsSim_OutputFcn(hObject, eventdata, handles) 

%Funcin de salida de la guide

varargout{1} = handles.output;

end


function tipo_Callback(hObject, eventdata, handles)

%Funcin que recoge el tipo de lnea

tipo=get(hObject,'value');  %Obtenemos la opcin seleccionada

 
t = ['-' '--' ':' '-.' ];%segn el valor seleccionado accedemos a la tabla

    
if tipo == 1
        b= t(1);
    elseif tipo== 2
        b= t(2:3);
    elseif tipo == 3
        b= t(4);
    elseif tipo == 4;
        b= t(5:6);
end
    
  handles.b=b;              %Guardamos la variable
  guidata(hObject, handles);
  
end

function ancho_Callback(hObject, eventdata, handles)

%Funcin que recoge el ancho de la lnea

ancho=get(hObject,'value');      % Obtenemos la opcin seleccionada
 
t = [1 2 5 10 20];      % segn el valor seleccionado accedemos a la tabla

    
if ancho==1
    a= t(1);
elseif ancho==2
    a= t(2);
elseif ancho==3
    a= t(3);
elseif ancho==4
    a= t(4);
elseif ancho==5
    a= t(5);
end

    handles.a=a;
   guidata(hObject, handles); %Guardamos la variable
   
end

function elcolor_Callback(hObject, eventdata, handles)

%Funcin que recoge el color de la lnea

elcolor=get(hObject,'value');           % Obtenemos la opcin seleccionada

% segn el valor seleccionado accedemos a la tabla
 
t = ['r' 'y' 'm' 'c' 'g' 'b' 'w' 'k']; 
    
if elcolor== 1
    val= t(1);
elseif elcolor == 2
    val= t(2);
elseif elcolor == 3
    val= t(3);
elseif elcolor == 4
    val= t(4);
elseif elcolor == 5
    val= t(5);
elseif elcolor == 6
    val= t(6);
elseif elcolor == 7
    val= t(7);
 elseif elcolor == 8
    val= t(8);
end
 
 
   handles.val=val;                  %Guardamos la variable
   guidata(hObject, handles);      
   
end


function Abrir_Callback(hObject, eventdata, handles)

%Funcin que abre la imagen que deseamos mostrar

[imagen, path] = uigetfile('*.*'); %Abrir imagen

if imagen==0    % Si cancelamos vuelve
    return
end

imagen=imread(strcat(path,imagen));

axes(handles.axes2)  %Muestra la imagen en el recuadro de la izquierda
imshow(imagen)
axis off 

axes(handles.axes3)  %Muestra la imagen en el recuadro de la derecha
imshow(imagen)
axis off 

[M N F]=size(imagen);         % Hallamos las dimensiones de la imagen

handles.imagen=imagen;      % Guardamos la imagen
guidata(hObject, handles);
 
handles.N=N;                % Guardamos el nmero de filas de la imagen
guidata(hObject, handles);
K2=imagen;
K3=imagen;
K4=0;

handles.M=M;                % Guardamos el nmero de columnas de la imagen
guidata(hObject, handles);

handles.K=M;                % Guardamos el nmero de columnas de la imagen
guidata(hObject, handles);

handles.K2=K2;             % Guardamos el nmero de columnas de la imagen
guidata(hObject, handles);

handles.K3=K3;                % Guardamos el nmero de columnas de la imagen
guidata(hObject, handles);

end

function linea_Callback(hObject, eventdata, handles)

%Funcin que pinta una lnea seleccionando punto inicial y final de la lnea

M=handles.M;    %Recogemos valores necesarios
N=handles.N;
b=handles.b;
a=handles.a;
val=handles.val;

        
hold on                    % Seleccin de puntos y dibujo de la lnea
[x1,y1] = ginput(1);
[x2,y2] = ginput(1);
line([x1 x2], [y1 y2],'LineWidth',a,'LineStyle',b,'Color',val);



 K=getframe; % Captura de la imagen,redimensin y guardamos de la variable
 K2=K.cdata;
 K2=imresize(K2,[M,N]);
 handles.K2=K2;
 guidata(hObject, handles);
 
end


function clear_Callback(hObject, eventdata, handles)    

%Funcin que restaura la imagen a su valor inicial


imagen=handles.imagen;

clear handles.axes2  
clear handles.axes3

axes(handles.axes2)
imshow(imagen);
axis off 

axes(handles.axes3) 
imshow(imagen);
axis off

f=1;
 handles.f=f;
 guidata(hObject, handles);
end


function distancia_Callback(hObject, eventdata, handles)

%Funcin que halla la distancia entre dos puntos

[xx1,yy1] = ginput(1);
[xx2,yy2] = ginput(1);

line([xx1 xx2], [yy1 yy2],'LineWidth',1,'LineStyle','none','Color','r','Marker','+');

x=abs(xx2-xx1); % valor absoluto de la resta e puntos
y=abs(yy2-yy1);

d=sqrt(x*x+y*y); % Aplicamos pitgoras

handles.d=d;                % Guardamos la variable
guidata(hObject, handles); 
set(handles.cm,'string',d); % Mostramos el valor

end

function angulo_Callback(hObject, eventdata, handles)

%Funcin que calcula el ngulo entre 3 puntos siendo el primero el centro

M=handles.M;  % Variables necesarias
N=handles.N;

% Obtencin de puntos
[xxx1,yyy1] = ginput(1);  % centro  
[xxx2,yyy2] = ginput(1);
[xxx3,yyy3] = ginput(1);
 
% Calculo del ngulo
   u1=xxx2-xxx1;
     u2=yyy2-yyy1;
     v1=xxx3-xxx1;
     v2=yyy3-yyy1;   


cosA=abs(u1*v1+u2*v2)/(sqrt(u1*u1+u2*u2)*sqrt(v1*v1+v2*v2));
alfa=acos(cosA)*(180/pi);

handles.alfa=alfa;          % Guardamos la variable
guidata(hObject, handles);
line([xxx1 xxx2], [yyy1 yyy2],'LineWidth',1,'LineStyle','-','Color','r','Marker','+','MarkerEdgeColor','b','MarkerSize',12);
line([xxx1 xxx3], [yyy1 yyy3],'LineWidth',1,'LineStyle','-','Color','r');   
line([xxx2 xxx3], [yyy2 yyy3],'LineWidth',1,'LineStyle','none','Marker','+','MarkerEdgeColor','y','MarkerSize',12);  
text(xxx1,yyy1,{alfa},'color','g')  
    
 
   set(handles.ang,'string',alfa);
   
K=getframe; % Captura de la imagen,redimensin  y guardamos de la variable
K2=K.cdata;
K2=imresize(K2,[M,N]);
handles.K2=K2;
guidata(hObject, handles);
  
end


function elcolor2_Callback(hObject, eventdata, handles)

%Funcin que captura el color para el contorno

elcolor2=get(hObject,'value');  % Obtenemos la opcin seleccionada

% segn el valor seleccionado accedemos a la tabla

t = ['r' 'y' 'm' 'c' 'g' 'b' 'w' 'k'];  

if elcolor2== 1
    val2= t(1);
elseif elcolor2 == 2
    val2= t(2);
elseif elcolor2 == 3
    val2= t(3);
elseif elcolor2 == 4
    val2= t(4);
elseif elcolor2 == 5
    val2= t(5);
elseif elcolor2 == 6
    val2= t(6);
elseif elcolor2 == 7
    val2= t(7);
 elseif elcolor2 == 8
    val2= t(8);
                             
end  
 
   handles.val2=val2;           % Guardamos la variable
   guidata(hObject, handles);

end

function CONTORNO_Callback(hObject, eventdata, handles)

%Funcin que pinta el contorno de un rea seleccionada

val2=handles.val2; % variables requeridas
M=handles.M;
N=handles.N;

% axes(handles.axes2) % Captura de puntos. Pulsar intro para terminar     
%  [X,Y] = ginput;
   axes(handles.axes2)

h=impoly;
 setColor(h,val2)
% F=getPosition(h);
% 
% 
% axes(handles.axes2)
% hold on
% fill(F(:,1),F(:,2),val2)

% Captura de la imagen,redimensin  y guardamos de la variable

K=getframe(handles.axes2);  
K2=K.cdata;
K2=imresize(K2,[M,N]);
handles.K2=K2;
guidata(hObject, handles);
 
end

function guardar_Callback(hObject, eventdata, handles)

%Funcin que guarda la imagen de la izquierda

  K2=handles.K2;  % variable que necesita

 [nomb, path] = uiputfile({'*.jpg';'*.jpeg';'*.bmp';'*.png';'*.tif'}, 'GUARDAR IMAGEN'); % Dnde se guarda
    
 if nomb==0  % Si se cancela la accin vuelve
     return
 end 
 
   fName = fullfile(path,nomb); 

   imwrite(K2,fName); % Guarda la imagen

end



function ExtraccionDeContorno_Callback(hObject, eventdata, handles)

  %Funcin que extrae el contorno
  
M=handles.M; % Variables requeridas
N=handles.N;
K2=handles.K2;


C=K2; % Renombre de variable

% Obtencin de componentes en color 

% Componente rojo

Br=C(:,:,1);
Br=im2bw(Br,0.9999999);

[LBr,NBr] = bwlabel(Br);
CBr= bwconncomp(LBr);
BBr = labelmatrix(CBr);
statsBr = regionprops(BBr, 'Area');

idx = find([statsBr.Area] > (M/10));
BWBr = ismember(BBr, idx);               
Br =BWBr ;  
Br=imfill(Br,'holes');

% Componente verde

Bg=C(:,:,2);
Bg=im2bw(Bg,0.9999999);

[LBg,NBg] = bwlabel(Bg);
CBg= bwconncomp(LBg);
BBg = labelmatrix(CBg);
statsBg = regionprops(BBg, 'Area');        
idx = find([statsBg.Area] > (M/10));
BWBg = ismember(BBg, idx);               
Bg =BWBg ;
Bg=imfill(Bg,'holes');

% Componente azul

Bb=C(:,:,3);
Bb=im2bw(Bb,0.999999);

[LBb,NBb] = bwlabel(Bb);
CBb= bwconncomp(LBb);
BBb = labelmatrix(CBb);
statsBb = regionprops(BBb, 'Area');        
idx = find([statsBb.Area] > (M/10));
BWBb = ismember(BBb, idx);               
Bb =BWBb ;  
Bb=imfill(Bb,'holes');

% Recomposicin de la imagen

DRGB=[];
DRGB(:,:,1)=Br;
DRGB(:,:,2)=Bg;
DRGB(:,:,3)=Bb;


idx = find(DRGB(:,:,1)==1 & DRGB(:,:,2)==1 & DRGB(:,:,3)==1);
Br(idx)=0;
Bg(idx)=0;
Bb(idx)=0;

DRGB=[];
DRGB(:,:,1)=Br;
DRGB(:,:,2)=Bg;
DRGB(:,:,3)=Bb;

Br=DRGB(:,:,1);
Br=im2bw(Br,0.9999999);
CBr= bwconncomp(Br);
BBr = labelmatrix(CBr);
statsBr = regionprops(BBr, 'Eccentricity');
idx = find([statsBr.Eccentricity] < 0.98);
BWBr = ismember(BBr, idx);               
Br =BWBr ; 
Br=imfill(Br,'holes');
se = strel('disk',3);
Br=imopen(Br,se);
Br=imclose(Br,se);

Bg=DRGB(:,:,2);
Bg=im2bw(Bg,0.9999999);
CBg= bwconncomp(Bg);
BBg = labelmatrix(CBg);
statsBg = regionprops(BBg, 'Eccentricity');
idx = find([statsBg.Eccentricity] < 0.98);
BWBg = ismember(BBg, idx);               
Bg =BWBg ; 
Bg=imfill(Bg,'holes');
Bg=imopen(Bg,se);
Bg=imclose(Bg,se);


Bb=DRGB(:,:,3);
Bb=im2bw(Bb,0.9999999);
CBb= bwconncomp(Bb);
BBb = labelmatrix(CBb);
statsBb = regionprops(BBb, 'Eccentricity');
idx = find([statsBb.Eccentricity] < 0.98);
BWBb = ismember(BBb, idx);               
Bb =BWBb ; 
Bb=imfill(Bb,'holes');
Bb=imopen(Bb,se);
Bb=imclose(Bb,se);

DRGB=[];
DRGB(:,:,1)=Br;
DRGB(:,:,2)=Bg;
DRGB(:,:,3)=Bb;
% Se muestra la salida

axes(handles.axes3) 
imshow(DRGB)
axis off 


K3=getframe;% Captura de la imagen,redimensin  y guardamos de la variable
K3=K3.cdata;
K3=imresize(K3,[M,N],'nearest');
handles.K3=K3;
guidata(hObject, handles);

handles.DRGB=DRGB;           % Guardamos la variable
guidata(hObject, handles);

K4=0;
handles.K4=K4;           % Guardamos la variable
guidata(hObject, handles);

end


function GIRAR_Callback(hObject, eventdata, handles)

  %Funcin que gira el objeto deseado

M=handles.M;    % variables requeridas
N=handles.N;
K2=handles.K2;
K4=handles.K4;
K5=handles.K5;
imagen=handles.imagen;
f=handles.f;
msg=handles.msg;   % Recibimos el valor de del ngulo de giro

% eliminamos las comillas para que puede leer el dato

msg = base2dec(msg, 10);


if f==1
K3=getframe; % Captura de la imagen,redimensin  y guardamos de la variable
K3=K3.cdata;
K3=double(K3);
K3=imresize(K3,[M,N],'nearest');
else
end

if K4==0
K3=getframe; % Captura de la imagen,redimensin  y guardamos de la variable
K3=K3.cdata;
K3=double(K3);
K3=imresize(K3,[M,N],'nearest');
 % Para evitar que al girar la imagen aada el borde en cada iteracin
if K5==1
    im=handles.im;
    K3=im-imagen;
    K3=double(K3);
else
end
 
 K2=K3;
% Obtencin de componentes en color 

% Componente rojo

Br=K2(:,:,1);
Bg=K2(:,:,2);
Bb=K2(:,:,3);
D=Br+Bg+Bb;

else
    K3=handles.K3;
if K5==1
    im=handles.im;
    K3=im-imagen;
    K3=double(K3);
else
    if f==1
K3=getframe; % Captura de la imagen,redimensin  y guardamos de la variable
K3=K3.cdata;
K3=double(K3);
K3=imresize(K3,[M,N],'nearest');
else
end
end   
    
    K2=K3;
    Br=K2(:,:,1);
Bg=K2(:,:,2);
Bb=K2(:,:,3);
D=Br+Bg+Bb;
D=double(D);
 [M44 N44 J4]=size(D);
 z=ones(M44,N44,J4);
 z(1:7,:,:)=0;
 z(M44-10:M44,:,:)=0;
 z(:,1:7,:)=0;
 z(:,N44-5:N44,:)=0;
 
 D=D.*z;
end



% Capturamos el punto del objeto a girar
[X,Y] = ginput(1);

% Redondeamos el valor obtenido
 Px=round(Y);
 Py=round(X);
  % Hallamos el valor del pixel del objeto
 P5 = impixel(K3,Py,Px);

% Hallamos componentes conexas de la imagen. Reiteramos para no machacar el
% valor anterior

[L,N1] = bwlabel(D);
[L2,N5] = bwlabel(D);
N2=L(Px,Py); % Nmero de componente conexa del objeto selecionado
 
% Seleccionamos el resto de componentes conexas y las hacemos cero

idx=find(L~=N2);
L(idx)=0;

% Buscamos el centroide del objeto a girar

 s  = regionprops(L, 'centroid');
 centroids = cat(1, s.Centroid);

% Redondeamos la posicin x e y del centroide

  c1=round(centroids(N2));
  c2=round(centroids(N2+N2)); 

% Giramos la imagen

DRGB2=imrotate(L,msg);

% Buscamos el centroide de la imagen girada

s2  = regionprops(DRGB2, 'centroid');   
centroids2 = cat(1, s2.Centroid);


% Redondeamos la posicin del centroide

 c3=round(centroids2(N2));
 c4=round(centroids2(N2+N2));

% Restmos las posicines de los centroides para ver cunto se han movido
   
  xc=c3-c1;
  xy=c4-c2;

% Hallamos las dimensiones de la imagen original y la girada

  [M7 N7 J3]=size(K3);
  [M3 N3 J3]=size(DRGB2);  

 % Proceso para mantener las dimensiones de la imagen original
 % Primero nos encargamos de la posicin en el eje hotizontal
 
if xc>0

    DRGB3=DRGB2(1:M3,xc:N3);

else
    
    xc=xc*(-1);
    z=zeros(M3,xc);
    DRGB3=[z DRGB2];  
    
end

% Miramos cmo se ha quedado el tamao 

[M8 N8 J3]=size(DRGB3);
 
% Ahora la posicin vertical
   
  if xy>0
      
      DRGB3=DRGB3(xy:M8,1:N8);
      
  else
      
      xy=xy*(-1);
      z=zeros(xy,N8);
      DRGB3=[z;DRGB3];  

  end
 
 % Comprobamos el tamao de la imagen
 
 [M4 N4 J3]=size(DRGB3);
  
 % Reconstruimos la imagen
 
  if M4>=M7
      
      DRGB3=DRGB3(1:M7,1:N4);
      
  else
      
      z=zeros(M7-M4,N4);           
      DRGB3=[DRGB3;z];
    
  end
  
  if N4>=N7
      
      DRGB3=DRGB3(1:M7,1:N7);
      
  else
      
      z=zeros(M7,N7-N4);
      DRGB3=[DRGB3 z];
      
  end

% Construimos vector de ceros con el tamao de la imagen

 H3=zeros([M7,N7,1]) ;

 % Devolvemos el color a la imagen segn el valor del pixel hallado
 % anteriormente
 
 if P5(1)==0
     
     HR=H3;
 else
     
     HR=DRGB3;
 end

if P5(2)==0
    
    HG=H3;
    
else
     
     HG=DRGB3;
end

if P5(3)==0
    
    HB=H3;
    
else
    
    HB=DRGB3;
    
end

% Reconstruimos la imagen

 H2=[];
 H2(:,:,1)=HR;
 H2(:,:,2)=HG;
 H2(:,:,3)=HB;


% Hacemos el objeto seleccionado cero y el resto original

 idx3=find(L==N2);
 L2(idx3)=0;


% Pasamos el formato a tipo double


K3=double(K3); 

% Construimos matriz (componente de imagen original *imagen original 
% sin objeto) + componente del objeto girado

 DRGB55=[];
 DRGB55(:,:,1)=((K3(:,:,1).*L2.*D))+HR;
 DRGB55(:,:,2)=((K3(:,:,2).*L2.*D))+HG;
 DRGB55(:,:,3)=((K3(:,:,3).*L2.*D))+HB;

K3=DRGB55;
K3=im2uint8(K3);
handles.K3=K3;                   % Guardamos la variable y mostramos
guidata(hObject, handles);
K4=1;
handles.K4=K4;                   % Guardamos la variable y mostramos

guidata(hObject, handles);
axes(handles.axes3) 
imshow(K3)
axis off 

end





function IntroduzcaAngulo_Callback(hObject, eventdata, handles)

 %Funcin que recoge el valor del ngulo a girar
 
msg= get(hObject,'string'); % Captura el valor

handles.msg=msg;            % Guarda la variable
guidata(hObject, handles); 

end

function mover_Callback(hObject, eventdata, handles)

%Funcin que hace mover el obejto las coordenadas que escribas

M=handles.M;   % Variables requeridas
N=handles.N;
K4=handles.K4;
K5=handles.K5;
imagen=handles.imagen;
f=handles.f;

if f==1
K3=getframe; % Captura de la imagen,redimensin  y guardamos de la variable
K3=K3.cdata;
K3=double(K3);
K3=imresize(K3,[M,N],'nearest');
else
end

if K4==0
K3=getframe; % Captura de la imagen,redimensin  y guardamos de la variable
K3=K3.cdata;
K3=double(K3);
K3=imresize(K3,[M,N],'nearest');
if K5==1
    im=handles.im;
    K3=im-imagen;
    K3=double(K3);
else
end
else
    K3=handles.K3;
    if K5==1
    im=handles.im;
    K3=im-imagen;
    K3=double(K3);
    else
    end
    if f==1
K3=getframe; % Captura de la imagen,redimensin  y guardamos de la variable
K3=K3.cdata;
K3=double(K3);
K3=imresize(K3,[M,N],'nearest');
else
end
end

K6=K3;              % Renombrar la variable

% Recogemos el valor de la distancia x e y a mover y le quitamos las
% comillas

dx=handles.dx;  
dx = textscan(dx,char);
dx=cell2mat(dx);
dx=im2double(dx); 
dy=handles.dy;
dy=char(dy);
dy = textscan(dy,char);
dy=cell2mat(dy);
dy=im2double(dy); 
[M44 N44 J4]=size(K6); % Tamao de la imagen

% Para evitar que al girar la imagen aada el borde en cada iteracin

z=ones(M44,N44,J4);      
z(1:2,:,:)=0;
z(M44-5:M44,:,:)=0;
z(:,1:7,:)=0;
z(:,N44-5:N44,:)=0;
K6=double(K6);
K6=K6.*z;

% Obtencin de componentes en color + apertura + cierre

% Componente rojo

Br=K6(:,:,1);
Br=im2bw(Br,0.9999999);

% Componente verde

Bg=K6(:,:,2);
Bg=im2bw(Bg,0.9999999);


Bb=K6(:,:,3);
Bb=im2bw(Bb,0.999999);

D=Br+Bg+Bb;

% Capturamos el punto del objeto a mover

[X,Y] = ginput(1);

% Redondeamos el valor

 Px=round(Y);
 Py=round(X);

 % Hallamos el valor del pixel del objeto seleccionado
 
 P5 = impixel(K6,Py,Px);
% Hallamos componentes conexas de la imagen. Reiteramos para no machacar el
% valor anterior

[L,N] = bwlabel(D);  % Nmero de componente conexa del objeto sellecionado
[L2,N5] = bwlabel(D);

N2=L(Px,Py);    % Nmero de componente conexa del objeto seleccionado

% Seleccionamos el resto de componentes conexas y las hacemos cero

idx=find(L~=N2);
L(idx)=0;

% Obtenemos el centroide del objeto a mover
 
s  = regionprops(L, 'centroid');
centroids = cat(1, s.Centroid);

% Redondeamos las posiciones x e y del centroide

  c1=round(centroids(N2));
  c2=round(centroids(N2+N2));

  % Proceso para mantener las dimensiones de la imagen original
 % Primero nos encargamos de la posicin en el eje hotizontal 

  if dx>0
      
  z2=zeros(M44,dx);
  K7=[z2 L];
  K7=K7(1:M44,1:N44);

  elseif dx==0
      
      K7=L;
      
  else
      
      dx=dx*(-1);
      z3=zeros(M44,dx);
      K7=L(1:M44,dx+1:N44);
      K7=[K7 z3];

  end
   
  % Ahora la posicin vertical
 
   if dy>0
       
      z=zeros(dy,N44);
      K8=[K7;z];
       [M47 N47 J4]=size(K8);
%       K8=K8(dy:M47-1,1:N47);
   
      K8=K8(dy:M47-1,1:N47);

  elseif dy==0
    
      K8=K7(1:M44,1:N44);
      
   else
       
      dy=dy*(-1);
      z3=zeros(dy,N44);
      K8=[z3;K7];
      K8=K8(1:M44,1:N44);


   end

   % Construimos matriz de ceros con el tamao de la imagen
   s  = regionprops(K8, 'centroid');
centroids = cat(1, s.Centroid);


   H3=zeros([M44,N44,1]) ;

  % Devolvemos le color a la imagen segn el valor del pixel obtenido
  % anteriormente

 if P5(1)==0
     
      HR=H3;
      
 else
     
     HR=K8;
     
 end

if P5(2)==0
    
     HG=H3;
     
else
    
    HG=K8;
    
end

if P5(3)==0
     
    HB=H3;
    
else
    
    HB=K8;
    
end

% Reconstruimos las componentes

 H2=[];
 H2(:,:,1)=HR;
 H2(:,:,2)=HG;
 H2(:,:,3)=HB;
 
 % Hacemos el onjeto seleccionado cero y el resto lo dejamos como estaba
 
 idx3=find(L==N2);
 L2(idx3)=0;

% Construimos matriz (componente de imagen original *imagen original 
% sin objeto) + componente del objeto girado

DRGB55=[];
 DRGB55(:,:,1)=(K6(:,:,1).*L2)+HR;
 DRGB55(:,:,2)=(K6(:,:,2).*L2)+HG;
 DRGB55(:,:,3)=(K6(:,:,3).*L2)+HB;
 
 K3= DRGB55;
 K3=im2uint8(K3);
 
handles.K3=K3;                   % Guardamos la variable y mostramos
guidata(hObject, handles);

K4=1;
handles.K4=K4;                   % Guardamos la variable y mostramos
guidata(hObject, handles);

axes(handles.axes3) 
imshow(K3)
axis off 
   
end



function EjeHorizontal_Callback(hObject, eventdata, handles)


 %Funcin que recoge el valor x a mover
 
dx= get(hObject,'string'); % Obtenemos y guardamos la variable
handles.dx=dx;
guidata(hObject, handles); 

end


function EjeVertical_Callback(hObject, eventdata, handles)

 %Funcin que recoge el valor y a mover
 
dy= get(hObject,'string'); % Obtenemos y guardamos la variable
handles.dy=dy;
guidata(hObject, handles); 

end

function Puntos_Callback(hObject, eventdata, handles)

  %Funcin que representa un punto en la imagen en el recuadro de la
  %izquierda
  
impoint(handles.axes2);
 
end

function Puntos2_Callback(hObject, eventdata, handles)

 %Funcin que representa un punto en la imagen en el recuadro de la
 %derecha
  
impoint(handles.axes3);

end

function Guardar2_Callback(hObject, eventdata, handles)

 %Funcin guarda la imagen de la derecha
  
 K3=handles.K3;  % Variable requerida
  
 % Obtiene el directorio a guardar
 
 [nomb, path] = uiputfile({'*.jpg';'*.jpeg';'*.bmp';'*.png';'*.tif'}, 'GUARDAR IMAGEN'); 
    
 if nomb==0, 
     return
 end 
 
  fName = fullfile(path,nomb); 

  imwrite(K3,fName);  % Guarda la imagen
   
end



function medidor_distancia_Callback(hObject, eventdata, handles)

%Funcin que representa una lnea

imdistline;

end


function figure1_CloseRequestFcn(hObject, eventdata, handles)

%Funcin que pregunta al salir si realmente lo desea

s=questdlg('Ests seguro que deseas salir?','SALIR','SI','NO','NO');

if strcmp(s,'NO')
    return
end

delete(hObject);

end


function Ayuda_Callback(hObject, eventdata, handles)

%Funcin que abre en una ventana nueva la ayuda en formato pdf

winopen('ayuda.pdf');

end

function menu_distancia_Callback(hObject, eventdata, handles)

%Funcin que crea una herramineta para medir distancias

hdist = imdistline(gca);
wait(hdist);

end

function menu_angulo_Callback(hObject, eventdata, handles)
%Funcin que calcula el ngulo entre 3 puntos siendo el primero el centro
% Es una replica de la funcin ngulo anterior pero situada en el men
% superior

M=handles.M;  % Variables necesarias
N=handles.N;

% Obtencin de puntos
[xxx1,yyy1] = ginput(1);  % centro  
[xxx2,yyy2] = ginput(1);
[xxx3,yyy3] = ginput(1);
 
% Calculo del ngulo
   u1=xxx2-xxx1;
     u2=yyy2-yyy1;
     v1=xxx3-xxx1;
     v2=yyy3-yyy1;   


cosA=abs(u1*v1+u2*v2)/(sqrt(u1*u1+u2*u2)*sqrt(v1*v1+v2*v2));
alfa=acos(cosA)*(180/pi);

handles.alfa=alfa;          % Guardamos la variable
guidata(hObject, handles);
line([xxx1 xxx2], [yyy1 yyy2],'LineWidth',1,'LineStyle','-','Color','r','Marker','+','MarkerEdgeColor','b','MarkerSize',12);
line([xxx1 xxx3], [yyy1 yyy3],'LineWidth',1,'LineStyle','-','Color','r');   
line([xxx2 xxx3], [yyy2 yyy3],'LineWidth',1,'LineStyle','none','Marker','+','MarkerEdgeColor','y','MarkerSize',12);  
text(xxx1,yyy1,{alfa},'color','g')  
    
 
   set(handles.ang,'string',alfa);
   
K=getframe; % Captura de la imagen,redimensin  y guardamos de la variable
K2=K.cdata;
K2=imresize(K2,[M,N]);
handles.K2=K2;
guidata(hObject, handles);

end

function menu_clear_Callback(hObject, eventdata, handles)

%Funcin que restaura la imagen a su valor inicial


imagen=handles.imagen;

clear handles.axes2  
clear handles.axes3

axes(handles.axes2)
imshow(imagen);
axis off 

axes(handles.axes3) 
imshow(imagen);
axis off

f=1;
 handles.f=f;
 guidata(hObject, handles);
end


function Trasladar_Callback(hObject, eventdata, handles)

%Funcin que traslada el obejto a la posicin indicada

M=handles.M; % Variables requeridas
N=handles.N;
K4=handles.K4;
K5=handles.K5;
imagen=handles.imagen;
f=handles.f;
% Captura de la imagen,redimensin  y guardamos de la variable
if f==1
K3=getframe; % Captura de la imagen,redimensin  y guardamos de la variable
K3=K3.cdata;
K3=double(K3);
K3=imresize(K3,[M,N],'nearest');
else
end

if K4==0
K3=getframe;
K3=K3.cdata;
K3=double(K3);
K3=imresize(K3,[M,N]);
if K5==1
    im=handles.im;
    K3=im-imagen;
    K3=double(K3);
else
end
else
    K3=handles.K3;
if K5==1
    im=handles.im;
    K3=im-imagen;
    K3=double(K3);
else
end
if f==1
K3=getframe; % Captura de la imagen,redimensin  y guardamos de la variable
K3=K3.cdata;
K3=double(K3);
K3=imresize(K3,[M,N],'nearest');
else
end
end

K44=K3; % Cambio de variable
[M44 N44 J4]=size(K44); % Tamao de la imagen

% Para evitar que al girar la imagen aada el borde en cada iteracin

z=ones(M44,N44,J4);
z(1:2,:,:)=0;
z(M44-5:M44,:,:)=0;
z(:,1:7,:)=0;
z(:,N44-5:N44,:)=0;
K44=double(K44);
K44=K44.*z;

% Obtencin de componentes en color + apertura + cierre

% Componente rojo

Br=K44(:,:,1);
Br=im2bw(Br,0.9999999);

% Componente verde

Bg=K44(:,:,2);
Bg=im2bw(Bg,0.9999999);

% Componente azul

Bb=K44(:,:,3);
Bb=im2bw(Bb,0.999999);
 
% Suma de componentes

D=Br+Bg+Bb; 

% Obtenemos el punto del objeto  trasladar y punto donde vamos a colocar el
% el centroide del objeto

[X,Y] = ginput(1);
[d_x,d_y] = ginput(1);

% Redondeamos los valores

dx=round(X-d_x);
dy=round(Y-d_y);
Px=round(Y);
Py=round(X);
 
% Obtenemos el color del pixel del objeto a trasladar

P5 = impixel(K44,Py,Px);

% Hallamos componentes conexas de la imagen. Reiteramos para no machacar el
% valor anterior

[L,N] = bwlabel(D);
[L2,N5] = bwlabel(D);

% Nmero de la componente conexa del objeto seleccionado

N2=L(Px,Py);

% Hacemos cero lo que no sea objeto

idx=find(L~=N2);
L(idx)=0;

% haalmos centroide del objeto

 s  = regionprops(L, 'centroid');
 centroids = cat(1, s.Centroid);
 
% Redondeamos el valor del centroide

  c1=round(centroids(N2));
  c2=round(centroids(N2+N2));

 % Proceso para mantener las dimensiones de la imagen original
 % Primero nos encargamos de la posicin en el eje hotizontal 
 
  if dx>0
  z2=zeros(M44,dx);
  K5=[L z2];
  K5=K5(1:M44,dx:N44-1);
  K5=[K5 z2];

  elseif dx==0
      
      K5=L;
      
  else
      
      dx=dx*(-1);
      z3=zeros(M44,dx);
      K5=[z3 L];
      K5=K5(1:M44,1:N44);    
      
  end

  % Ahora la posicin vertical
  
   if dy>0
      
      z=zeros(dy,N44);
      K6=K5;
      [M47 N47 J4]=size(K5);
      K6=K6(dy:M47,1:N47);
      K6=[K6;z];
      K6=K6(1:M44,1:N47);

  elseif dy==0
      
      K6=K5(1:M44,1:N44);
      
   else
       
      dy=dy*(-1);
      z3=zeros(dy,N44);
      K6=[z3;K5];
      K6=K6(1:M44,1:N44);
      
   end
   
   % Creamos una matriz de ceros del tamao de la imagen
   
   H3=zeros([M44,N44,1]) ;

   % Volvemos a poner color al objeto
   
 if P5(1)==0
      
     HR=H3;
     
 else
     
     HR=K6;
     
 end

if P5(2)==0
     
    HG=H3;
    
else
    
    HG=K6;
    
end
if P5(3)==0
     
    HB=H3;
    
else
    
    HB=K6;
    
end

% Constuimos la imagen con sus componentes en color

 H2=[];
 H2(:,:,1)=HR;
 H2(:,:,2)=HG;
 H2(:,:,3)=HB;
 
 
 % Cogemos la imagen y acemos cero al objeto
 
 idx3=find(L==N2);
 L2(idx3)=0;

% Construimos matriz (componente de imagen original *imagen original 
% sin objeto) + componente del objeto girado

DRGB55=[];
 DRGB55(:,:,1)=(K44(:,:,1).*L2)+HR;
 DRGB55(:,:,2)=(K44(:,:,2).*L2)+HG;
 DRGB55(:,:,3)=(K44(:,:,3).*L2)+HB;
 
% Mostramos el resultado

 K3= DRGB55;
 K3=im2uint8(K3);
handles.K3=K3;                   % Guardamos la variable y mostramos
guidata(hObject, handles);
K4=1;
handles.K4=K4;                   % Guardamos la variable y mostramos
guidata(hObject, handles);
axes(handles.axes3) 
imshow(K3)
axis off 
end



function menu_linea_Callback(hObject, eventdata, handles)

% Funcin que pinta una lnea

imline(gca);

end



function menu_guardar_izquierda_Callback(hObject, eventdata, handles)

% Funcin replicada que guarda la imagen de la izquierda situada en el
% Men principal

  K2=handles.K2;  % variable que necesita

 [nomb, path] = uiputfile({'*.jpg';'*.jpeg';'*.bmp';'*.png';'*.tif'}, 'GUARDAR IMAGEN'); % Dnde se guarda
    
 if nomb==0  % Si se cancela la accin vuelve
     return
 end 
 
   fName = fullfile(path,nomb); 

   imwrite(K2,fName); % Guarda la imagen
end

function menu_guardar_derecha_Callback(hObject, eventdata, handles)
 
 %Funcin replicada que guarda la imagen de la derecha situada en el 
 % men superior
  
 K3=handles.K3;  % Variable requerida
  
 % Obtiene el directorio a guardar
 
 [nomb, path] = uiputfile({'*.jpg';'*.jpeg';'*.bmp';'*.png';'*.tif'}, 'GUARDAR IMAGEN'); 
    
 if nomb==0, 
     return
 end 
 
  fName = fullfile(path,nomb); 

  imwrite(K3,fName);  % Guarda la imagen
   
end

function herramienta_linea_Callback(hObject, eventdata, handles)


imline(gca);

end


function menu_salir_Callback(hObject, eventdata, handles)
close all
end


function axes2_CreateFcn(hObject, eventdata, handles)

axis off


end

function axes3_CreateFcn(hObject, eventdata, handles)

 axis off
 
end



function Colocar_sobre_imagen_Callback(hObject, eventdata, handles)

K3=handles.K3;
imagen=handles.imagen;
im=imagen+K3;
axes(handles.axes3)
imshow(im)
axis off

K3= im;

handles.K3=K3;                   % Guardamos la variable y mostramos
guidata(hObject, handles);
K5=1;
handles.K5=K5;
guidata(hObject, handles);
handles.im=im;
guidata(hObject, handles);
end


function texto_Callback(hObject, eventdata, handles)
msg2=handles.msg2;

 [x,y]=ginput(1);
axes(gca)
text(x,y,msg2,'BackgroundColor',[.7 .9 .7])
end


function texto_edit_Callback(hObject, eventdata, handles)
msg2= get(hObject,'string');
handles.msg2=msg2;                % Guardamos el nmero de columnas de la imagen
guidata(hObject, handles);
end


function texto_edit_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

end



function menu_abrir_Callback(hObject, eventdata, handles)

%Funcin que abre la imagen que deseamos mostrar

[imagen, path] = uigetfile('*.*'); %Abrir imagen

if imagen==0    % Si cancelamos vuelve
    return
end

imagen=imread(strcat(path,imagen));

axes(handles.axes2)  %Muestra la imagen en el recuadro de la izquierda
imshow(imagen)
axis off 

axes(handles.axes3)  %Muestra la imagen en el recuadro de la derecha
imshow(imagen)
axis off 

[M N F]=size(imagen);         % Hallamos las dimensiones de la imagen

handles.imagen=imagen;      % Guardamos la imagen
guidata(hObject, handles);
 
handles.N=N;                % Guardamos el nmero de filas de la imagen
guidata(hObject, handles);
K2=imagen;
K3=imagen;
K4=0;

handles.M=M;                % Guardamos el nmero de columnas de la imagen
guidata(hObject, handles);

handles.K=M;                % Guardamos el nmero de columnas de la imagen
guidata(hObject, handles);

handles.K2=K2;             % Guardamos el nmero de columnas de la imagen
guidata(hObject, handles);

handles.K3=K3;                % Guardamos el nmero de columnas de la imagen
guidata(hObject, handles);

end


function menu_dist_Callback(hObject, eventdata, handles)
%Funcin que halla la distancia entre dos puntos

[xx1,yy1] = ginput(1);
[xx2,yy2] = ginput(1);

line([xx1 xx2], [yy1 yy2],'LineWidth',1,'LineStyle','none','Color','r','Marker','+');

x=abs(xx2-xx1); % valor absoluto de la resta e puntos
y=abs(yy2-yy1);

d=sqrt(x*x+y*y); % Aplicamos pitgoras

handles.d=d;                % Guardamos la variable
guidata(hObject, handles); 
set(handles.cm,'string',d); % Mostramos el valor
end



function menu_puntos_izqda_Callback(hObject, eventdata, handles)

impoint(handles.axes2);

end


function menu_imagen_derecha_Callback(hObject, eventdata, handles)

impoint(handles.axes3);

end



function menu_contorno_Callback(hObject, eventdata, handles)

%Funcin que pinta el contorno de un rea seleccionada

val2=handles.val2; % variables requeridas
M=handles.M;
N=handles.N;

% axes(handles.axes2) % Captura de puntos. Pulsar intro para terminar     
%  [X,Y] = ginput;
   axes(handles.axes2)

h=impoly;
 setColor(h,val2)
% F=getPosition(h);
% 
% 
% axes(handles.axes2)
% hold on
% fill(F(:,1),F(:,2),val2)

% Captura de la imagen,redimensin  y guardamos de la variable

K=getframe(handles.axes2);  
K2=K.cdata;
K2=imresize(K2,[M,N]);
handles.K2=K2;
guidata(hObject, handles);

end

function Untitled_3_Callback(hObject, eventdata, handles)

  %Funcin que extrae el contorno
  
M=handles.M; % Variables requeridas
N=handles.N;
K2=handles.K2;


C=K2; % Renombre de variable

% Obtencin de componentes en color 

% Componente rojo

Br=C(:,:,1);
Br=im2bw(Br,0.9999999);

[LBr,NBr] = bwlabel(Br);
CBr= bwconncomp(LBr);
BBr = labelmatrix(CBr);
statsBr = regionprops(BBr, 'Area');

idx = find([statsBr.Area] > (M/10));
BWBr = ismember(BBr, idx);               
Br =BWBr ;  
Br=imfill(Br,'holes');

% Componente verde

Bg=C(:,:,2);
Bg=im2bw(Bg,0.9999999);

[LBg,NBg] = bwlabel(Bg);
CBg= bwconncomp(LBg);
BBg = labelmatrix(CBg);
statsBg = regionprops(BBg, 'Area');        
idx = find([statsBg.Area] > (M/10));
BWBg = ismember(BBg, idx);               
Bg =BWBg ;
Bg=imfill(Bg,'holes');

% Componente azul

Bb=C(:,:,3);
Bb=im2bw(Bb,0.999999);

[LBb,NBb] = bwlabel(Bb);
CBb= bwconncomp(LBb);
BBb = labelmatrix(CBb);
statsBb = regionprops(BBb, 'Area');        
idx = find([statsBb.Area] > (M/10));
BWBb = ismember(BBb, idx);               
Bb =BWBb ;  
Bb=imfill(Bb,'holes');

% Recomposicin de la imagen

DRGB=[];
DRGB(:,:,1)=Br;
DRGB(:,:,2)=Bg;
DRGB(:,:,3)=Bb;


idx = find(DRGB(:,:,1)==1 & DRGB(:,:,2)==1 & DRGB(:,:,3)==1);
Br(idx)=0;
Bg(idx)=0;
Bb(idx)=0;

DRGB=[];
DRGB(:,:,1)=Br;
DRGB(:,:,2)=Bg;
DRGB(:,:,3)=Bb;

Br=DRGB(:,:,1);
Br=im2bw(Br,0.9999999);
CBr= bwconncomp(Br);
BBr = labelmatrix(CBr);
statsBr = regionprops(BBr, 'Eccentricity');
idx = find([statsBr.Eccentricity] < 0.98);
BWBr = ismember(BBr, idx);               
Br =BWBr ; 
Br=imfill(Br,'holes');
se = strel('disk',3);
Br=imopen(Br,se);
Br=imclose(Br,se);

Bg=DRGB(:,:,2);
Bg=im2bw(Bg,0.9999999);
CBg= bwconncomp(Bg);
BBg = labelmatrix(CBg);
statsBg = regionprops(BBg, 'Eccentricity');
idx = find([statsBg.Eccentricity] < 0.98);
BWBg = ismember(BBg, idx);               
Bg =BWBg ; 
Bg=imfill(Bg,'holes');
Bg=imopen(Bg,se);
Bg=imclose(Bg,se);


Bb=DRGB(:,:,3);
Bb=im2bw(Bb,0.9999999);
CBb= bwconncomp(Bb);
BBb = labelmatrix(CBb);
statsBb = regionprops(BBb, 'Eccentricity');
idx = find([statsBb.Eccentricity] < 0.98);
BWBb = ismember(BBb, idx);               
Bb =BWBb ; 
Bb=imfill(Bb,'holes');
Bb=imopen(Bb,se);
Bb=imclose(Bb,se);

DRGB=[];
DRGB(:,:,1)=Br;
DRGB(:,:,2)=Bg;
DRGB(:,:,3)=Bb;
% Se muestra la salida

axes(handles.axes3) 
imshow(DRGB)
axis off 


K3=getframe;% Captura de la imagen,redimensin  y guardamos de la variable
K3=K3.cdata;
K3=imresize(K3,[M,N],'nearest');
handles.K3=K3;
guidata(hObject, handles);

handles.DRGB=DRGB;           % Guardamos la variable
guidata(hObject, handles);

K4=0;
handles.K4=K4;           % Guardamos la variable
guidata(hObject, handles);

end

function menu_trasladar_Callback(hObject, eventdata, handles)

%Funcin que traslada el obejto a la posicin indicada

M=handles.M; % Variables requeridas
N=handles.N;
K4=handles.K4;
K5=handles.K5;
imagen=handles.imagen;
f=handles.f;
% Captura de la imagen,redimensin  y guardamos de la variable
if f==1
K3=getframe; % Captura de la imagen,redimensin  y guardamos de la variable
K3=K3.cdata;
K3=double(K3);
K3=imresize(K3,[M,N],'nearest');
else
end

if K4==0
K3=getframe;
K3=K3.cdata;
K3=double(K3);
K3=imresize(K3,[M,N]);
if K5==1
    im=handles.im;
    K3=im-imagen;
    K3=double(K3);
else
end
else
    K3=handles.K3;
if K5==1
    im=handles.im;
    K3=im-imagen;
    K3=double(K3);
else
end
if f==1
K3=getframe; % Captura de la imagen,redimensin  y guardamos de la variable
K3=K3.cdata;
K3=double(K3);
K3=imresize(K3,[M,N],'nearest');
else
end
end

K44=K3; % Cambio de variable
[M44 N44 J4]=size(K44); % Tamao de la imagen

% Para evitar que al girar la imagen aada el borde en cada iteracin

z=ones(M44,N44,J4);
z(1:2,:,:)=0;
z(M44-5:M44,:,:)=0;
z(:,1:7,:)=0;
z(:,N44-5:N44,:)=0;
K44=double(K44);
K44=K44.*z;

% Obtencin de componentes en color + apertura + cierre

% Componente rojo

Br=K44(:,:,1);
Br=im2bw(Br,0.9999999);

% Componente verde

Bg=K44(:,:,2);
Bg=im2bw(Bg,0.9999999);

% Componente azul

Bb=K44(:,:,3);
Bb=im2bw(Bb,0.999999);
 
% Suma de componentes

D=Br+Bg+Bb; 

% Obtenemos el punto del objeto  trasladar y punto donde vamos a colocar el
% el centroide del objeto

[X,Y] = ginput(1);
[d_x,d_y] = ginput(1);

% Redondeamos los valores

dx=round(X-d_x);
dy=round(Y-d_y);
Px=round(Y);
Py=round(X);
 
% Obtenemos el color del pixel del objeto a trasladar

P5 = impixel(K44,Py,Px);

% Hallamos componentes conexas de la imagen. Reiteramos para no machacar el
% valor anterior

[L,N] = bwlabel(D);
[L2,N5] = bwlabel(D);

% Nmero de la componente conexa del objeto seleccionado

N2=L(Px,Py);

% Hacemos cero lo que no sea objeto

idx=find(L~=N2);
L(idx)=0;

% haalmos centroide del objeto

 s  = regionprops(L, 'centroid');
 centroids = cat(1, s.Centroid);
 
% Redondeamos el valor del centroide

  c1=round(centroids(N2));
  c2=round(centroids(N2+N2));

 % Proceso para mantener las dimensiones de la imagen original
 % Primero nos encargamos de la posicin en el eje hotizontal 
 
  if dx>0
  z2=zeros(M44,dx);
  K5=[L z2];
  K5=K5(1:M44,dx:N44-1);
  K5=[K5 z2];

  elseif dx==0
      
      K5=L;
      
  else
      
      dx=dx*(-1);
      z3=zeros(M44,dx);
      K5=[z3 L];
      K5=K5(1:M44,1:N44);    
      
  end

  % Ahora la posicin vertical
  
   if dy>0
      
      z=zeros(dy,N44);
      K6=K5;
      [M47 N47 J4]=size(K5);
      K6=K6(dy:M47,1:N47);
      K6=[K6;z];
      K6=K6(1:M44,1:N47);

  elseif dy==0
      
      K6=K5(1:M44,1:N44);
      
   else
       
      dy=dy*(-1);
      z3=zeros(dy,N44);
      K6=[z3;K5];
      K6=K6(1:M44,1:N44);
      
   end
   
   % Creamos una matriz de ceros del tamao de la imagen
   
   H3=zeros([M44,N44,1]) ;

   % Volvemos a poner color al objeto
   
 if P5(1)==0
      
     HR=H3;
     
 else
     
     HR=K6;
     
 end

if P5(2)==0
     
    HG=H3;
    
else
    
    HG=K6;
    
end
if P5(3)==0
     
    HB=H3;
    
else
    
    HB=K6;
    
end

% Constuimos la imagen con sus componentes en color

 H2=[];
 H2(:,:,1)=HR;
 H2(:,:,2)=HG;
 H2(:,:,3)=HB;
 
 
 % Cogemos la imagen y acemos cero al objeto
 
 idx3=find(L==N2);
 L2(idx3)=0;

% Construimos matriz (componente de imagen original *imagen original 
% sin objeto) + componente del objeto girado

DRGB55=[];
 DRGB55(:,:,1)=(K44(:,:,1).*L2)+HR;
 DRGB55(:,:,2)=(K44(:,:,2).*L2)+HG;
 DRGB55(:,:,3)=(K44(:,:,3).*L2)+HB;
 
% Mostramos el resultado

 K3= DRGB55;
 K3=im2uint8(K3);
handles.K3=K3;                   % Guardamos la variable y mostramos
guidata(hObject, handles);
K4=1;
handles.K4=K4;                   % Guardamos la variable y mostramos
guidata(hObject, handles);
axes(handles.axes3) 
imshow(K3)
axis off 
end

function menu_colcocar_Callback(hObject, eventdata, handles)

K3=handles.K3;
imagen=handles.imagen;
im=imagen+K3;
axes(handles.axes3)
imshow(im)
axis off

K3= im;

handles.K3=K3;                   % Guardamos la variable y mostramos
guidata(hObject, handles);
K5=1;
handles.K5=K5;
guidata(hObject, handles);
handles.im=im;
guidata(hObject, handles);
end

